﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Prova1.Persistence;

namespace Prova1.Model
{
    public class Exam
    {
        private readonly IList<Question> _questions;
        private int _currentQuestionIndex = -1;

        public Exam(IList<Question> questions)
        {
            if (questions == null)
                throw new ArgumentNullException("questions");
            if (questions.Count == 0)
                throw new ArgumentException("questions.Count == 0");
            _questions = questions;
        }

        public Question CurrentQuestion
        {
            get { return (0 <= CurrentQuestionIndex && CurrentQuestionIndex < _questions.Count) ? _questions[CurrentQuestionIndex] : null; }
        }

        public int CurrentQuestionIndex
        {
            get { return _currentQuestionIndex; }
            set { _currentQuestionIndex = value; }
        }

        public double GetScore()
        {
            double score = 0;
            foreach (Question question in _questions)
            {
                score += question.GetScore();
            }
            return score;
        }
    }
}
