﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prova1.Model
{
    public class MultipleChoiceQuestion : Question
    {
        private readonly IList<Answer> _answers;
        private Answer _givenAnswer;

        public MultipleChoiceQuestion(IList<Answer> answers)
        {
            if (answers == null)
                throw new ArgumentNullException("answers");
            if (answers.Count == 0)
                throw new ArgumentException("answers.Count == 0");
            _answers = answers;
            _givenAnswer = null;
        }

        public IEnumerable<Answer> Answers
        {
            get { return _answers; }
        }

        public void SetGivenAnswer(Answer answer)
        {
            if (answer != null && !_answers.Contains(answer))
                throw new ArgumentException("answer != null && !_answers.Contains(answer)");
            _givenAnswer = answer;
        }

        public override double GetScore()
        {
            if (_givenAnswer != null)
            {
                return _givenAnswer.Points;
            }
            else
            {
                return 0;
            }
        }
    }
}
