﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Prova1.Model;

namespace Prova1.Presentation
{
    [QuestionType(typeof(FillInTheBlanksQuestion))]
    public partial class FillInTheBlanksControl : UserControl, IQuestionControl
    {
        private readonly FillInTheBlanksQuestion _question;

        public FillInTheBlanksControl(FillInTheBlanksQuestion question)
        {
            _question = question;
            InitializeComponent();
            Build();
        }

        #region Implementation of IQuestionControl

        public void SetGivenAnswer()
        {
            foreach (Control control in _flowLayoutPanel.Controls)
            {
                if (control.Tag is EditablePart)
                {
                    TextBox textBox = (TextBox) control;
                    _question.SetGivenAnswer((EditablePart) textBox.Tag, textBox.Text);
                }
            }
        }

        #endregion

        private void Build()
        {
            _flowLayoutPanel.Controls.Clear();
            _idLabel.Text = _question.Id;
            _textLabel.Text = _question.Text;
            foreach (IPart part in _question.Parts)
            {
                if (part is TextPart)
                {
                    Label label = new Label();
                    label.Text = ((TextPart) part).Text;
                    label.TextAlign = ContentAlignment.MiddleLeft;
                    label.Width = label.PreferredWidth;
                    _flowLayoutPanel.Controls.Add(label);
                }
                else if (part is EditablePart)
                {
                    TextBox textBox = new TextBox();
                    textBox.Tag = part;
                    _flowLayoutPanel.Controls.Add(textBox);
                }
                else
                {
                    throw new ApplicationException();
                }
            }
        }
    }
}
