﻿using System;
using System.Windows.Forms;

using Prova1.Model;

namespace Prova1.Presentation
{
    public partial class MainForm : Form, IMainView
    {
        private IQuestionControl _questionControl;

        public MainForm()
        {
            InitializeComponent();
        }

        #region Implementation of IMainView

        public event EventHandler StartButtonClick
        {
            add { _startButton.Click += value; }
            remove { _startButton.Click -= value; }
        }

        public event EventHandler NextButtonClick
        {
            add { _nextButton.Click += value; }
            remove { _nextButton.Click -= value; }
        }

        public bool StartButtonEnabled
        {
            get { return _startButton.Enabled; }
            set { _startButton.Enabled = value; }
        }

        public bool NextButtonEnabled
        {
            get { return _nextButton.Enabled; }
            set { _nextButton.Enabled = value; }
        }

        public IQuestionControl QuestionControl
        {
            get { return _questionControl; }
            set
            {
                if (value != _questionControl)
                {
                    _questionControl = value;
                    _panel.Controls.Clear();
                    if (_questionControl != null)
                    {
                        Control questionControl = (Control) _questionControl;
                        questionControl.Dock = DockStyle.Fill;
                        _panel.Controls.Add(questionControl);
                    }
                }
            }
        }

        public string StatusText
        {
            get { return _statusLabel.Text; }
            set { _statusLabel.Text = value; }
        }

        #endregion
    }
}
