﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Prova1.Model;

namespace Prova1.Presentation
{
    [QuestionType(typeof(MultipleChoiceQuestion))]
    public partial class MultipleChoiceControl : UserControl, IQuestionControl
    {
        private readonly MultipleChoiceQuestion _question;

        public MultipleChoiceControl(MultipleChoiceQuestion question)
        {
            _question = question;
            InitializeComponent();
            Build();
        }

        #region Implementation of IQuestionControl

        public void SetGivenAnswer()
        {
            Answer givenAnswer = null;
            foreach (RadioButton answerRadioButton in _answersPanel.Controls)
            {
                if (answerRadioButton.Checked)
                {
                    givenAnswer = (Answer) answerRadioButton.Tag;
                    break;
                }
            }
            _question.SetGivenAnswer(givenAnswer);
        }

        #endregion

        private void Build()
        {
            _answersPanel.Controls.Clear();
            _idLabel.Text = _question.Id;
            _textLabel.Text = _question.Text;
            foreach (Answer answer in _question.Answers)
            {
                AddAnswer(answer);
            }
            AddAnswer(null);
        }

        private void AddAnswer(Answer answer)
        {
            RadioButton answerRadioButton = new RadioButton();
            if (answer != null)
            {
                answerRadioButton.Text = answer.Text;
                answerRadioButton.Tag = answer;
            }
            else
            {
                answerRadioButton.Text = "Nessuna risposta data";
                answerRadioButton.Checked = true;
            }
            answerRadioButton.AutoSize = true;
            _answersPanel.Controls.Add(answerRadioButton);
        }
    }
}
