﻿using System;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Windows.Forms;
using System.Collections.Generic;

using Prova1.Model;
using Prova1.Persistence;
using Prova1.Presentation;

namespace Prova1
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            XmlExamReader examReader = new XmlExamReader(new StreamReader("../../Exam.xml"));
            Exam exam = new Exam(examReader.ReadQuestions());
            MainForm mainForm = new MainForm();
            QuestionControlFactory questionControlFactory = new QuestionControlFactory(Assembly.GetExecutingAssembly());
            MainController mainController = new MainController(exam, mainForm, questionControlFactory);
            Application.Run(mainForm);
        }
    }
}
