﻿using Prova1.Model;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using System;
using System.Linq;

namespace Prova1Test
{


    /// <summary>
    ///This is a test class for FillInTheBlanksQuestionTest and is intended
    ///to contain all FillInTheBlanksQuestionTest Unit Tests
    ///</summary>
    [TestClass()]
    public class FillInTheBlanksQuestionTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for SetGivenAnswer
        ///</summary>
        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void SetGivenAnswerTest1()
        {
            FillInTheBlanksQuestion target = CreateQuestion();
            EditablePart editablePart = null;
            target.SetGivenAnswer(editablePart, "testo1");
        }

        /// <summary>
        ///A test for SetGivenAnswer
        ///</summary>
        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void SetGivenAnswerTest2()
        {
            FillInTheBlanksQuestion target = CreateQuestion();
            EditablePart editablePart = new EditablePart();
            target.SetGivenAnswer(editablePart, "testo1");
        }

        /// <summary>
        ///A test for SetGivenAnswer
        ///</summary>
        [TestMethod()]
        public void SetGivenAnswerTest3()
        {
            FillInTheBlanksQuestion target = CreateQuestion();
            target.SetGivenAnswer((EditablePart) target.Parts.ElementAt(1), "testo1");
        }

        /// <summary>
        ///A test for GetScore
        ///</summary>
        [TestMethod()]
        public void GetScoreTest()
        {
            FillInTheBlanksQuestion target = CreateQuestion();
            Assert.AreEqual(0, target.GetScore());
            target.SetGivenAnswer((EditablePart) target.Parts.ElementAt(1), null);
            Assert.AreEqual(0, target.GetScore());
            target.SetGivenAnswer((EditablePart) target.Parts.ElementAt(1), String.Empty);
            Assert.AreEqual(0, target.GetScore());
            target.SetGivenAnswer((EditablePart) target.Parts.ElementAt(1), "testoX");
            Assert.AreEqual(-0.25, target.GetScore());
            target.SetGivenAnswer((EditablePart) target.Parts.ElementAt(1), "testo1");
            Assert.AreEqual(1.5, target.GetScore());
        }

        /// <summary>
        ///A test for FillInTheBlanksQuestion Constructor
        ///</summary>
        [TestMethod()]
        public void FillInTheBlanksQuestionConstructorTest()
        {
            FillInTheBlanksQuestion target = CreateQuestion();
            Assert.AreEqual(5, target.Parts.Count());
        }

        [TestMethod()]
        [ExpectedException(typeof(ArgumentNullException))]
        public void FillInTheBlanksQuestionConstructorTest1()
        {
            FillInTheBlanksQuestion target = new FillInTheBlanksQuestion(null);
        }

        [TestMethod()]
        [ExpectedException(typeof(ArgumentException))]
        public void FillInTheBlanksQuestionConstructorTest2()
        {
            FillInTheBlanksQuestion target = new FillInTheBlanksQuestion(new List<IPart>());
        }

        private FillInTheBlanksQuestion CreateQuestion()
        {
            return new FillInTheBlanksQuestion(new List<IPart>()
                {
                   new TextPart(),
                   new EditablePart() { ExpectedText = "Testo1", RightAnswerPoints = 1.5, WrongAnswerPoints = -0.25 },
                   new TextPart(),
                   new EditablePart() { ExpectedText = "Testo3", RightAnswerPoints = 1, WrongAnswerPoints = -0.5 },
                   new TextPart()
                });
        }
    }
}
