﻿using Prova1.Presentation;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Reflection;
using Prova1.Model;
using System;
using System.Collections.Generic;

namespace Prova1Test
{


    /// <summary>
    ///This is a test class for QuestionControlFactoryTest and is intended
    ///to contain all QuestionControlFactoryTest Unit Tests
    ///</summary>
    [TestClass()]
    public class QuestionControlFactoryTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for GetQuestionControlFor
        ///</summary>
        [TestMethod()]
        public void GetQuestionControlForTest1()
        {
            QuestionControlFactory target = new QuestionControlFactory(Assembly.GetExecutingAssembly());
            Question question = new DummyQuestion(1);
            IQuestionControl actual;
            actual = target.GetQuestionControlFor(question);
            Assert.IsNotNull(actual);
            Assert.IsInstanceOfType(actual, typeof(DummyQuestionControl));
        }

        [TestMethod()]
        [ExpectedException(typeof(ApplicationException))]
        public void GetQuestionControlForTest2()
        {
            QuestionControlFactory target = new QuestionControlFactory(Assembly.GetExecutingAssembly());
            Question question = new MultipleChoiceQuestion(new List<Answer>() { new Answer() });
            IQuestionControl actual;
            actual = target.GetQuestionControlFor(question);
        }

        [TestMethod()]
        public void GetQuestionControlForTest3()
        {
            QuestionControlFactory target = new QuestionControlFactory(AppDomain.CurrentDomain.GetAssemblies());
            Question question = new DummyQuestion(1);
            IQuestionControl actual;
            actual = target.GetQuestionControlFor(question);
            Assert.IsNotNull(actual);
            Assert.IsInstanceOfType(actual, typeof(DummyQuestionControl));
            //question = new MultipleChoiceQuestion(new List<Answer>() { new Answer() });
            //actual = target.GetQuestionControlFor(question);
            //Assert.IsNotNull(actual);
            //Assert.IsInstanceOfType(actual, typeof(MultipleChoiceControl));
            question = new FillInTheBlanksQuestion(new List<IPart>() { new EditablePart() });
            actual = target.GetQuestionControlFor(question);
            Assert.IsNotNull(actual);
            Assert.IsInstanceOfType(actual, typeof(FillInTheBlanksControl));
        }
    }

    [QuestionType(typeof(DummyQuestion))]
    public class DummyQuestionControl : IQuestionControl
    {
        private readonly DummyQuestion _question;

        public DummyQuestionControl(DummyQuestion question)
        {
            _question = question;
        }

        #region Implementation of IQuestionControl

        public void SetGivenAnswer()
        {
        }

        #endregion
    }
}
